/*/////////////////////////////////////////////////////////*/
#include <stdio.h>
#include "ecatdmodpistruct.h"
#include "ethercatdef.h"
#include <const.h>
#include <stddef.h>
#include <sysglob.h>
#include <signal.h>
#include <pthread.h>
#define HOME	"\x1b[H"
#define CLRSC 	"\x1b[2J"

u_int32 ticps () // 
{

	glob_buff myg;
	_os_getsys (offsetof(sysglobs, d_tcksec ),sizeof(u_int16),&myg);
	return myg.wrd;

}

int main (int argc,char**argv) {

	char* pilay = "ECAT_pi_layout";
	char* piin = "ECAT_pi_in";
	char* piout= "ECAT_pi_out";
	char* evnam = "ECAT_pi_ev_sync";
	struct ecat_off_len knurr = {0,0};
	error_code myerr;
	signal_code sig;
	u_int32 timeout,inval,innval,zval,hits;
	int32 adval;

	if((myerr= ecat_accpi_open(piin,piout,pilay,evnam))!=SUCCESS) exit(myerr);
	adval=ecat_accpi_inout_size();
	zval=0;
	myerr = ecat_accpi_find_in_var("Inputs.SlaveCount",&knurr);
	ecat_in4.len=8;
	printf("%s",CLRSC);
	do {

		/* wait for ethercat cycle finish*/
		if( (myerr= ecat_pi_wait()) !=SUCCESS) exit(myerr);
		/* now ethercat cycle waits until we are done*/
		inval= ecat_pi_in(ecat_in0)+ecat_pi_in(ecat_in1)*2+ecat_pi_in(ecat_in2)*4+ecat_pi_in(ecat_in3)*8;
		ecat_in2.len=8;
		innval= ecat_pi_in(ecat_in2);
		ecat_in2.len=1;
		ecat_pi_out(zval&1,ecat_out0);
		ecat_pi_out(zval&2,ecat_out1);
		ecat_pi_out(zval&4,ecat_out2);
		ecat_pi_out(zval&8,ecat_out3);
		if(++zval>15) zval=0;
		/*printf("%s counter:%d \n",HOME,inval);*/
		/*we are done--------------*/
		if((myerr= 	ecat_pi_trigger())!=SUCCESS) exit(myerr);
		timeout=ticps()/10;
		 /*_os_sleep(&timeout,&sig);  wait 10 ms*/
		_os_gs_ready(0,&hits);
	} while (hits==0); /* loop until any key hit*/
	printf("\n\n");
	if((myerr=ecat_accpi_close())) exit(myerr);	 
	return 0;
}
